%{
// $Header: /usr/local/cvs/bisonpp/doc/expparser.y,v 1.1.1.1 1999/03/17 13:02:33 dvermeir Exp $

#include	"expparser.h"
%}

%union	{
	int	val;
	}

%token NAME  NUMBER LPAREN RPAREN EQUAL PLUS MINUS 
%token TIMES DIVIDE GO

/*	associativity and precedence: in order of increasing precedence */

%nonassoc	EQUAL
%left		PLUS	MINUS
%left		TIMES	DIVIDE
%left		UMINUS	/* dummy token to use as precedence marker */

%type		<val> NUMBER exp

%%
prog		: exp 
			{
			cout << $1 << endl;
			}
		;

exp		: exp PLUS exp
			{
			$$ = $1 + $3;
			}
		| exp MINUS exp
			{
			$$ = $1 - $3;
			}
		| exp TIMES exp
			{
			$$ = $1 * $3;
			}
		| exp DIVIDE exp
			{
			if ($3)
				$$ = $1 / $3;
			}
		| LPAREN exp RPAREN
			{
			$$ = $2;
			}
		| MINUS exp 	%prec UMINUS /* this will force a reduce */
			{
			$$ = -$2;
			}
		| NUMBER
			{
			$$ = $1;
			}
		;
%%

